# -*- coding: utf-8 -*-
import os
import math
import sys
import re
import string
import numpy as np
#2-dim 版　2022.04.07
#assertion を無効にしたい場合は、python -O xxx.py にする。
#originalは岩上さん
#コメントとプログラムの見かけだけを変更、岩上さんのプログラムと全く同じ動作をする。大野
#2021.05.06 パラメータ値(minX maxX...,p0,cuboid_len,beta1,beta2,gamma1,gamma2)を外部ファイルからの入力にする。
#2021.05.06 ２次曲線アルゴリズムを追加する。
#2021.05.06 assertionを入れる。
#
#
#parameterファイルのパス #2-dim
parameter_file_pass = './parameters.2dim'
#
#pointsファイルのパス
file_pass = './points'
#変更したpointsを書き出すファイル
#
write_file = open("./spider_points","w")
#
#pointsファイルのpointが始まる行数と終わる行数
Number_of_lines_starti=1
Number_of_lines_point_starti=21
#Number_of_lines_points_num=19
Number_of_lines_points_num=18 #openfoam version 9
Number_of_lines_point_endi=Number_of_lines_points_num #19
##########################変数定義　infinity-値で初期設定する。値はパラメータファイルから入力する。
#無限大値を定義する。
f_inf = float('inf')
#立方体の長さ x,y,z cuboidの設定のみに使用
cuboid_len=np.array([f_inf,f_inf,f_inf])
#p0:蜘蛛の巣に拡大する時の中心点
p0=np.array([f_inf,f_inf,f_inf])
#直方体の何割を細かく残すかを決める変数　,拡大率を増やしていく範囲 gamma1 ~ gamma2
gamma1=f_inf
gamma2=f_inf
#拡大率
beta1=f_inf
beta2=f_inf
#=============ohnoここから
#assertion check
#パラメータチェック
def paramCheck(p0,cuboid_ln,gamma1,gamma2,beta1,beta2):
        assert(p0[0] != f_inf)
        assert(p0[1] != f_inf)
        assert(p0[2] != f_inf)
        assert(cuboid_ln[0] != f_inf)
        assert(cuboid_ln[1] != f_inf)
        assert(cuboid_ln[2] != f_inf)
        assert(gamma1 != f_inf)
        assert(gamma2 != f_inf)
        assert(beta1 != f_inf)
        assert(beta2 != f_inf)
        assert(0. < gamma1)
        assert(gamma1 < gamma2)
        assert(beta1 == 1.)
        assert(beta1 < beta2)
        return
#係数の計算（オリジナル）
def _factor2(v,r,R):
        if r  < v and v < R :
                return ((beta2 - beta1)/(R - r)) *(v - r) + 1.
        elif v <= r  :
                return beta1
        elif v >= R :
                return beta2
#係数の計算（２次曲線）
def _factor(x,r,R):
		if x < 0. : 
			assert False
#
		if x <= r :
                        return beta1
#
		if x >= R :
                        return beta2
#
		a = (beta2 - beta1)/((R - r)*(R - r));
		
		b = -2.*r*a;
		
		c = beta1 - a*r*r -b*r;
		
		return a*x*x + b*x +c;
	
#max法による係数の計算（オリジナル）
def maxMethod_factor(p):  #pは正規化されている点情報
        p_max=[math.fabs(p[0]),math.fabs(p[1]),math.fabs(p[2])]
        p_max=max(p_max)
        alpha=_factor(p_max,gamma1,gamma2)
        return alpha
#==============ohnoここまで
#平行移動
def translation_point(p,ptra):
	return p-ptra
#正規化の関数
def nomalize_point(p,c):
	return p/c
#正規化の逆関数
def inverse_nomalize_point(p,c):
	return p*c
#2021.05.06 ohno
##############parameterの入力##
paramFp = open(parameter_file_pass,'r')
for line in paramFp.readlines()   :
        line=line.translate(string.maketrans(':,()\n','     '))
        line=line.split()
        if len(line)==0 :continue
        if line[0]=='p0':
                p0[0]=float(line[1])
                p0[1]=float(line[2])
                p0[2]=float(line[3])
        if line[0]=='cuboid':
                cuboid_len[0]=float(line[1])
                cuboid_len[1]=float(line[2])
                cuboid_len[2]=float(line[3])
        if line[0]=='gamma1':
                gamma1=float(line[1])
        if line[0]=='gamma2':
                gamma2=float(line[1])
        if line[0]=='beta1':
                beta1= float(line[1])
        if line[0]=='beta2':
                beta2=float(line[1])
        if line[0]=='minX':
                minX=float(line[1])
        if line[0]=='minY':
                minY=float(line[1])
        if line[0]=='minZ':
                minZ=float(line[1])
        if line[0]=='maxX':
                maxX=float(line[1])
        if line[0]=='maxY':
                maxY=float(line[1])
        if line[0]=='maxZ':
                maxZ=float(line[1])
        if line[0]=='divX':
                divX=float(line[1])
        if line[0]=='divY':
                divY=float(line[1])
        if line[0]=='divZ':
                divZ=float(line[1])
paramFp.close()
##############main#############
paramCheck(p0,cuboid_len,gamma1,gamma2,beta1,beta2)
######2021.05.06 ohno ここまで
fp = open(file_pass,'r')
i=Number_of_lines_starti
for line in fp.readlines()  :
    if i == Number_of_lines_points_num :
                #print "number of points : ",line
                line=line.translate(string.maketrans(',()','   '))
                #Number_of_lines_point_endi=int(line)+20
                Number_of_lines_point_endi=int(line)+19 #openfoam version 9
                i+=1
    elif i>=Number_of_lines_point_starti and i<=Number_of_lines_point_endi :
		line=line.translate(string.maketrans(',()','   '))
		line=line.split(' ')
		#print line
		x = float( line[1] )
		y = float( line[2] )
		z = float( line[3] )
#======ohno ここから
		p=np.array([x,y,z])
		if p[0]>=150. :
                	p=translation_point(p,p0)
                	p= nomalize_point(p,cuboid_len)
                	alpha =maxMethod_factor(p)
                	p=alpha*p
                	p=inverse_nomalize_point(p,cuboid_len)
                #	data="({0:1.9f} {1:1.9f} {2:1.9f})\n".format(p[0]+p0[0],p[1]+p0[1],p[2]+p0[2]) 
                	data="({0:1.9f} {1:1.9f} {2:1.9f})\n".format(p[0]+p0[0],p[1]+p0[1],z) #2-dim
                	write_file.write(data)
                	i+=1
		else:
			data="({0} {1} {2})\n".format(p[0],p[1],p[2])
			write_file.write(data)
			i+=1

    else :
		i+=1
		write_file.write(line)
write_file.close()
